package video;

import gui.run.ObservablePoint;
import gui.run.RunJob;
import j2d.ImageUtils;
import j2d.ShortImageBean;
import j2d.color.FloatImageBean;
import utils.ResourceManager;

import java.awt.*;
import java.net.MalformedURLException;
import java.util.Observable;
import java.util.Observer;

/**
 * Copyright 2005, DocJava, Inc.
 * User: dlyon
 * Date: Mar 28, 2006
 * Time: 1:14:03 PM
 */
public class Pantomation {

    private ObservablePoint observablePoint = new ObservablePoint();

    public ObservablePoint getObservablePoint() {
        return observablePoint;
    }

    public Pantomation(Observer obs) {
        observablePoint.addObserver(obs);
        new RunJob(.1) {
            public void run() {
                updatePoint();
            }
        };
    }

    public static void main(String[] args) throws MalformedURLException {
        //testChromaKeyTag();
        testPantograph();
    }

    private static void testPantograph() {
        Pantomation p = new Pantomation(new Observer() {
            public void update(Observable o, Object arg) {
                System.out.println(arg);
            }
        });
    }

    public void updatePoint() {
        observablePoint.setValue(getValue());
    }
    FloatImageBean fib = null;
    public Point getValue() {
        long start = System.currentTimeMillis();
        Image img = CameraUtils.getWebCamImage();
        // this takes a long time!
        fib = FloatImageBean.getFibYiq(img);
        System.out.println(System.currentTimeMillis() - start);
        Point colorLocation = fib.getColorLocation(27, 95, 43, 65);
        return colorLocation;
    }

    public static void testChromaKeyTag() {
        ResourceManager rm = ResourceManager.getResourceManager();
        Image img = ImageUtils.getImage(rm.getImageFile("finger.jpg"));
        ImageUtils.displayImage(img, "finger.jpg");
        FloatImageBean figYiq = FloatImageBean.getFibYiq(img);
        ShortImageBean sib = new ShortImageBean(img);
        figYiq.chromaMark(sib, 27, 95, 43, 65);
        for (int i = 205; i < 209; i++)
            for (int k = 100; k < 108; k++)
                printYuvValues(figYiq, i, k);
        ImageUtils.displayImage(sib.getImage(), "outputImage");
    }

    public static void printYuvValues(FloatImageBean fibYuv, int ix, int iy) {
        float y = fibYuv.getR()[ix][iy];
        float u = fibYuv.getG()[ix][iy];
        float v = fibYuv.getB()[ix][iy];

        System.out.println("y=" + y + " u=" + u + " v=" + v);
    }
}
