package video.broadcast;

import net.multicast.McastUtil;

import java.io.*;
import java.net.InetAddress;

/**
 * Copyright DocJava, inc.
 * User: lyon
 * Date: Oct 27, 2004
 * Time: 5:08:08 AM
 */
public class BroadcastViewerThread extends Thread {
    McastUtil mcu;

    public BroadcastViewerThread(McastUtil mcu) {
        this.mcu = mcu;
        setDaemon(false);
        start();                // start calls run
    }

    public void run() {
        String tmp;
        ImageFrame imgFrame = new ImageFrame();
        imgFrame.setVisible(true);
        try {
            while (true) {
                byte[] data = mcu.getBytes();
                InetAddress address = mcu.getInetAddress();
                ByteArrayInputStream bais =
                        new ByteArrayInputStream(data, 0, data.length);
                imgFrame.getImage(bais);
                System.out.println("\n\nRecived: \"" +
                        "ip=" + address +
                        "\"\nMessage Length is: " +
                        data.length);
            }
        } catch (IOException e) {
            System.out.println("Exit...");
            e.printStackTrace();
        }
    }

}
